﻿Type=Class
Version=3.71
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "HelperTablePage"
	' name of the app, same as in ABMApplication
	Public AppName As String = "demo"
	
	' your own variables
	Dim myToastId As Int
	Dim FirstNames As List
	Dim LastNames As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1	
	If ABMShared.NeedsAuthorization Then
		If ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, "../")
			Return
		End If
	End If
	' connect our page with the websocket	
	page.SetWebSocket(ws)
	' Prepare the page IMPORTANT!
	page.Prepare	
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map) 
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))					
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)				
		End Select
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	theme.AddTableTheme("tbl1theme")
	theme.Table("tbl1theme").ZDepth = ABM.ZDEPTH_1
	
	theme.Table("tbl1theme").AddCellTheme("headerfooter")
	theme.Table("tbl1theme").Cell("headerfooter").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbl1theme").Cell("headerfooter").ForeColor = ABM.COLOR_WHITE	
	
	theme.Table("tbl1theme").AddCellTheme("headerfooterright")
	theme.Table("tbl1theme").Cell("headerfooterright").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbl1theme").Cell("headerfooterright").ForeColor = ABM.COLOR_WHITE
	theme.Table("tbl1theme").Cell("headerfooterright").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbl1theme").AddCellTheme("positive")
	theme.Table("tbl1theme").Cell("positive").BackColor = ABM.COLOR_GREEN
	theme.Table("tbl1theme").Cell("positive").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbl1theme").Cell("positive").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbl1theme").AddCellTheme("negative")
	theme.Table("tbl1theme").Cell("negative").BackColor = ABM.COLOR_RED
	theme.Table("tbl1theme").Cell("negative").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbl1theme").Cell("negative").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbl1theme").AddCellTheme("aligntop")
	theme.Table("tbl1theme").Cell("aligntop").VerticalAlign = ABM.TABLECELL_VERTICALALIGN_TOP
	
	theme.AddCardTheme("whitetitle")
	theme.Card("whitetitle").TitleForeColor = ABM.COLOR_WHITE
	
	
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & AppName & "/" & Name, False, theme)
	page.ShowLoader=True
		
	ABMShared.BuildNavigationBar(page, "ABMTable", "../images/logo.png", "", "Helpers", "ABMTable")
		
	' create the page grid
	page.AddRows(6,True, "").AddCells12(1,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	FirstNames.Initialize2(Array As String("Alain", "Jos", "Paul", "Bertrande", "Julie", "Stephanie", "Bert", "Charles", "James", "Walter"))
	LastNames.Initialize2(Array As String("Bailleul", "Rogiers", "Dougherty", "Rodrigues", "Ostrander", "Kenyon", "Grant", "Klinger", "Sheffield", "Poindexter"))
	
	' add paragraph	
	page.Cell(1,1).AddComponent(ABMShared.BuildParagraph(page,"par1", "With tables you can create data grids. Tables have build-in goodies like being sortable. Click on the headers for a demo.") )
	
	' add paragraph	
	page.Cell(1,1).AddComponent(ABMShared.BuildParagraphBQ(page,"par1b", "The Id of a table {B}MAY NOT CONTAIN A _ CHARACTER!{/B}.  This is because of the inner working of nested table and the _ character is reserved.") )
	
	' create a table
	Dim tbl1 As ABMTable
	tbl1.Initialize(page, "tbl1", True, False, "tbl1theme")
	tbl1.SetHeadersWithTheme(Array As String("First Name", "Last Name", "Sales Profit"), Array As String("headerfooter", "headerfooter", "headerfooterright"))
	
	' add some random values
	For i = 0 To 9
		Dim r As List
		Dim rCellThemes As List
		r.Initialize
		rCellThemes.Initialize
		r.Add(FirstNames.get(Rnd(0,9)))
		rCellThemes.Add("")
		r.Add(LastNames.get(Rnd(0,9)))
		rCellThemes.Add("")		
		Dim Neg As Int = Rnd(0,100)
		If Neg > 50 Then
			r.Add("$" & Rnd(1000, 15000))
			rCellThemes.Add("positive")
		Else
			r.Add("$-" & Rnd(1000, 15000))
			rCellThemes.Add("negative")
		End If
		tbl1.AddRowWithTheme(r, rCellThemes) ' make sure you have as many items in rCellThemes as in r!
	Next
	
	tbl1.SetFooterWithTheme("This is a footer that appears on the bottom of the table.", 12,"headerfooter")
	
	page.Cell(2,1).AddComponent(tbl1)
	
	' add paragraph	
	page.Cell(3,1).AddComponent(ABMShared.BuildParagraph(page,"par1", "Tables can be scrollable.  You'll need to set the height of the parent cell and specify the column widths.") )
	
	' create a table scrollable
	Dim tbl2 As ABMTable
	tbl2.InitializeScrollable(page, "tbl2", True, False, Array As Int(300,300,150), "tbl1theme")
	tbl2.SetHeadersWithTheme(Array As String("First Name", "Last Name", "Sales Profit"), Array As String("headerfooter", "headerfooter", "headerfooterright"))
	
	' add some random values
	For i = 0 To 9
		Dim r As List
		Dim rCellThemes As List
		r.Initialize
		rCellThemes.Initialize
		r.Add(FirstNames.get(Rnd(0,9)))
		rCellThemes.Add("")
		r.Add(LastNames.get(Rnd(0,9)))
		rCellThemes.Add("")		
		Dim Neg As Int = Rnd(0,100)
		If Neg > 50 Then
			r.Add("$" & Rnd(1000, 15000))
			rCellThemes.Add("positive")
		Else
			r.Add("$-" & Rnd(1000, 15000))
			rCellThemes.Add("negative")
		End If
		tbl2.AddRowWithTheme(r, rCellThemes) ' make sure you have as many items in rCellThemes as in r!
	Next
	
	tbl2.SetFooterWithTheme("This is a footer that appears on the bottom of the table.", 12,"headerfooter")
	
	' scrollable, so we need to set a fixed height IMPORTANT!
	page.Cell(4,1).SetFixedHeight(200)
	page.Cell(4,1).AddComponent(tbl2)
	
	' add paragraph	
	page.Cell(5,1).AddComponent(ABMShared.BuildParagraph(page,"par1", "Tables can contain all kind of ABM components.  In the example below we have Cards and even another table (the profits) as a column. Also, it is made interactive so we receive a clicked() event when we click into a cell. Check the source code of this page on how it is done.") )
		
	' add paragraph	
	page.Cell(5,1).AddComponent(ABMShared.BuildParagraphBQ(page,"par2", "Because the profits are random created, the value it reutrns will not match the one you clicked.  This is because when the page was build other values were saved in the html than the ones shown.  In a real world app you would get the values from a database for example so they would match.") )
	
	' create a table scrollable
	Dim tbl3 As ABMTable
	tbl3.InitializeScrollable(page, "tbl3", False, True, Array As Int(300, 200,200,150), "tbl1theme")
	tbl3.SetHeadersWithTheme(Array As String("Card", "First Name", "Last Name", "Sales Profit"), Array As String("headerfooter", "headerfooter", "headerfooter", "headerfooterright"))
	
	Dim fName, lName As String
	
	' add some random values
	For i = 0 To 9
		Dim r As List
		Dim rCellThemes As List
		r.Initialize
		rCellThemes.Initialize
		fName = FirstNames.get(Rnd(0,9))
		lName = LastNames.get(Rnd(0,9))
		r.Add(BuildCard("card","../images/list" & (i+1) & ".jpg", fName & " " & lName)) ' <--- note we do not give every card a unique id.  
		rCellThemes.Add("aligntop")
		r.Add(fName)
		rCellThemes.Add("aligntop")
		r.Add(lName)
		rCellThemes.Add("aligntop")		
		r.Add(BuildOtherTable("innertable")) ' <--- note we do not give every innertable a unique id.  
		rCellThemes.Add("aligntop")
		tbl3.AddRowWithTheme(r, rCellThemes) ' make sure you have as many items in rCellThemes as in r!
	Next
	
	tbl3.SetFooterWithTheme("This is a footer that appears on the bottom of the table.", 12,"headerfooter")
	
	' scrollable, so we need to set a fixed height IMPORTANT!
	page.Cell(6,1).SetFixedHeight(500)
	page.Cell(6,1).AddComponent(tbl3)
	
	ABMShared.BuildFooter(page)
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition	
	If Action = "ABMTable" Then Return
	If Action = "Contact" Then	
		myToastId = myToastId + 1	
		page.ShowToast("toast" & myToastId, "toastred", "Hello to you too!", 5000)
		Return
	End If
	ABMShared.NavigateToPage(ws, Value)
End Sub

Sub Page_Ready()
	Log("ready!")
	page.RestoreNavigationBarPosition
End Sub

Sub BuildOtherTable(id As String) As ABMTable
	' create a table
	Dim tblinner As ABMTable
	tblinner.Initialize(page, id, True, True, "tbl1theme")
	
	Dim rand As Int = Rnd(1,20)
	For i = 0 To rand
		Dim r As List
		Dim rCellThemes As List
		r.Initialize
		rCellThemes.Initialize
		Dim Neg As Int = Rnd(0,100)
		If Neg > 50 Then
			r.Add("$" & Rnd(1000, 15000))
			rCellThemes.Add("positive")
		Else
			r.Add("$-" & Rnd(1000, 15000))
			rCellThemes.Add("negative")
		End If
		tblinner.AddRowWithTheme(r, rCellThemes) ' make sure you have as many items in rCellThemes as in r!
	Next
	Return tblinner
End Sub

Sub BuildCard(id As String, image As String, title As String) As ABMCard
	' image card
	Dim card4 As ABMCard
	card4.InitializeAsCard(page, "card", title, "This is my card content...", ABM.CARD_NOTSPECIFIED,"whitetitle")
	card4.Image = image
	Return card4
End Sub

' rows and columns are zero-base, meaning they start with row 0, cell 0
Sub tbl3_Clicked(PassedRowsAndColumns As List)
	' is the root table
	Dim tblCellInfo As ABMTableCell = PassedRowsAndColumns.Get(0)
	If tblCellInfo.Column = 0 Then
		Dim tbl As ABMTable = page.Cell(6,1).Component(tblCellInfo.TableName)
		Dim card As ABMCard = tbl.GetComponent(tblCellInfo.Row,"card")
		If card <> Null Then
			Log("We've got the card in row " & tblCellInfo.Row & " column " & tblCellInfo.Column & "!")
		End If
	End If
	myToastId = myToastId + 1	
	page.ShowToast("toast" & myToastId, "toastred", "Clicked " & tblCellInfo.TableName & " row " & tblCellInfo.Row & " column " & tblCellInfo.Column, 5000)
End Sub

' rows and columns are zero-base, meaning they start with row 0, cell 0
Sub innertable_Clicked(PassedRowsAndColumns As List)
	' this is more complicated
	' first we get the parent of our innertable
	Dim tblCellInfo As ABMTableCell = PassedRowsAndColumns.Get(0)
	Dim tbl As ABMTable = page.Cell(6,1).Component(tblCellInfo.TableName)
	' next we get our innertable
	Dim innerTblCellInfo As ABMTableCell = PassedRowsAndColumns.Get(1)
	Dim innerTbl As ABMTable = tbl.GetComponent(tblCellInfo.Row,innerTblCellInfo.TableName)
	' note the value will not be the right one because I used randomize in the BuildOtherTable() method.  So when be saved the page we got other values than when we connected through the websocket.
	' this is just to show the principle of getting a string value
	Dim profit As String = innerTbl.GetString(innerTblCellInfo.Row, innerTblCellInfo.Column)	
	myToastId = myToastId + 1	
	page.ShowToast("toast" & myToastId, "toastred", "Clicked row " & innerTblCellInfo.Row & " column " & innerTblCellInfo.Column & " value=" & profit , 5000)
	Return
End Sub


